#include "testlib.h"
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
	int n, k;
	int score = 30;
	n = inf.readInt();
	k = inf.readInt();
	bool flag = true;
	set <string> usedtokens;
    for (int i = 0; i < n; ++i) {
		string token = ouf.readWord();
		if (token.size() != k) {
			quitf(_wa, "Wrong token length at line %d", i + 1);
		}
		for (int j = 0; j < k; ++j) {
			if (!((token[j] >= '0' && token[j] <= '9') || (token[j] >= 'a' && token[j] <= 'f'))) {
				quitf(_wa, "Bad symbol at line %d", i + 1);
			}
		}
		if (usedtokens.find(token) != usedtokens.end()) {
			quitf(_wa, "Used token at line %d", i + 1);
		}
		usedtokens.insert(token);
		for (int j = 0; j < k; ++j) {
			string ntoken = token;
			ntoken[j] = '#';
			if (usedtokens.find(ntoken) != usedtokens.end()) {
				quitf(_wa, "Used modified token at line %d", i + 1);
			}
			usedtokens.insert(ntoken);
		}
	}
    quitp(score, "participant's solution is ok");
    return 0;
}