#include "testlib.h"
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
	int score = 0;
	int t = inf.readInt();
	for (int testno = 0; testno < t; ++testno) {
		int n = inf.readInt();
		int m = inf.readInt();
		int k = inf.readInt();
		vector <set <int>> usednums(n + 1);
		bool flag = true;
		for (int i = 0; i < m; ++i) {
			int compno = ouf.readInt();
			int fr = inf.readInt();
			int to = inf.readInt();
			if (compno < 1 || compno > k + 1) {
				quitf(_wa, "wrong company number %d at test %d", compno, t);
			}
			if (usednums[fr].find(compno) != usednums[fr].end() || usednums[to].find(compno) != usednums[to].end()) {
				flag = false;
			}
			usednums[fr].insert(compno);
			usednums[to].insert(compno);
		}
		if (flag) score += 5;
	}
    //quitp(score, "participant's solution is ok");
    quitf(_ok, "accepted for testing");
    return 0;
}